package oco.erreur;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;


public class XsdError implements ErrorHandler {
    StringBuffer message = null;


	public XsdError() {
		  message = new StringBuffer();
    }
	
	public void error(SAXParseException exception) throws SAXException {
		message.append("line ").append(exception.getLineNumber())
		.append(" column ").append(exception.getColumnNumber())
		.append(" : ").append(exception.getMessage());
	}
	
	public void warning(SAXParseException exception) throws SAXException {
		message.append("warning : line ").append(exception.getLineNumber())
		.append(" column ").append(exception.getColumnNumber())
		.append(" : ").append(exception.getMessage());
	}
	
	public void fatalError(SAXParseException exception) throws SAXException {
		message.append("FATAL : line ").append(exception.getLineNumber())
		.append(" column ").append(exception.getColumnNumber())
		.append(" : ").append(exception.getMessage());
	}
	
	public boolean hasErrorMessage() {
		return message.length() > 0;
	}

	public String getMessage() {
		return message.toString();
	}
}
