package oco.regles;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

import oco.erreur.MessageErrorManager;
import oco.traitement.CoNetcdfFile;
import oco.traitement.ConstantesXml;


public class FactoryRules {

	public static Regle createRule(Node xmlRule, MessageErrorManager p_report, CoNetcdfFile p_file) {
		Regle rule = null;

		String ruleName = xmlRule.getNodeName();
		String errorLevel = FactoryRules.getNiveauErreur(xmlRule);

		if (ruleName.equals(ConstantesXml.MANDATORY)) {
			rule = new Mandatory(p_file, p_report, errorLevel);
			rule.ruleBlocLevel = ConstantesXml.MANDATORY;
		}
		if (ruleName.equals(ConstantesXml.OPTIONAL)) {
			rule = new Optional(p_file, p_report, errorLevel);
			rule.ruleBlocLevel = ConstantesXml.OPTIONAL;
		}
		if (ruleName.equals(ConstantesXml.AT_LEAST)) {
			rule = new AtLeast(p_file, p_report, errorLevel);
			rule.ruleBlocLevel = ConstantesXml.AT_LEAST;
		}
		return rule;
	}

	private static String getNiveauErreur(Node xmlRule) {
		String errorLevel = null;
		NamedNodeMap niveauAttr = xmlRule.getAttributes();
		for (int i = 0; i < niveauAttr.getLength(); i++) {
			Node attribut = niveauAttr.item(i);
			if (attribut.getNodeName().equals(ConstantesXml.ERROR_LEVEL)) {
				errorLevel = attribut.getNodeValue();
			}
		}
		return errorLevel;
	}

}
