package oco.regles;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import oco.erreur.MessageErrorManager;
import oco.structure.ElementStructure;
import oco.traitement.CoNetcdfFile;
import oco.traitement.ConstantesXml;

public abstract class Regle {

    protected ArrayList<ElementStructure> ruleElements = null;
    
    protected HashMap<String, List> netcdfDatas = null;

    protected CoNetcdfFile netcdfFile = null;
    
    protected MessageErrorManager report = null;
    
    // MANDATORY, OPTIONAL, AT_LEAST
    protected String ruleBlocLevel = null;
    
    // ERROR, WARNING
    protected String ruleErrorLevel = ConstantesXml.ERROR;
    
    
	/**
	 * Constructeur
	 * 
	 */
    public Regle(CoNetcdfFile p_file, MessageErrorManager p_report, String p_errorLevel) {
        this.ruleElements = new ArrayList<ElementStructure>();
        this.netcdfDatas = new HashMap<String, List>();
        this.netcdfFile = p_file;
        this.report = p_report;
        if (p_errorLevel != null) {
        	this.ruleErrorLevel = p_errorLevel;
        }
    }

	/**
	 * 
	 * 
	 */
    public void add(ElementStructure p_element) {
    	this.ruleElements.add(p_element);
    }

	/**
	 * 
	 * 
	 */
    protected void gererErreur(List p_errors, String p_errorLevel) {
    	
    	String messProperties = null;
    	HashMap messageHM;
    	
        if (p_errors != null && p_errors.isEmpty() == false) {
        	
        	// pour chaque message d'erreur
            Iterator iter = p_errors.iterator();
            while (iter.hasNext()) {
            	
                String [] tabError = (String [])iter.next();
                int codeErreur = Integer.parseInt(tabError[0]);
                messProperties = recupererMessageErreur(codeErreur);
                messageHM = genererDonneesErreur(tabError);
                this.report.addFileError(messProperties, messageHM, p_errorLevel);
            }
        }
    }
    
	/**
	 * 
	 * 
	 */
    protected HashMap genererDonneesErreur(String [] p_datas) {
        HashMap<String,String> p_datasHM = new HashMap<String,String>();
        StringBuffer clef = null;
        for (int i = 1 ; i < p_datas.length; i++) {
        	clef = new StringBuffer();
        	clef.append("{").append(i-1).append("}");
        	p_datasHM.put(clef.toString(), p_datas[i]);
        }
        return p_datasHM;
    }

	/**
	 * 
	 * 
	 */
    public abstract void executerRegles();

	/**
	 * 
	 * 
	 */
    protected abstract String recupererMessageErreur(int codeErreur);

}
