package oco.structure;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import oco.erreur.ErreurRegles;

public class CoAttribute extends ElementSimple {

	private String value;

	/**
	 * Constructeur
	 * 
	 */
	public CoAttribute() {
		super();
	}

	
	public String getValue() {
		return this.value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	
	/**
	 * 
	 * 
	 */
	public boolean egaliteAvec(Object object, ArrayList<String []> lstErreur) {
		boolean status = false;
		boolean equals = false;
		String rulesValueAsString = null;
		String rulesValueAsPattern = null;
		String netcdfValueAsString = null;
		Double rulesValueAsNumber = null;
		Double netcdfValueAsNumber = null;
		
		if (object instanceof CoAttribute) {
			CoAttribute netcdfAttribute = (CoAttribute) object;

			// Le nom de l'attribut est obligatoire
			if (this.getName() != null) {
				
				if (this.getName().equals(netcdfAttribute.getName())){
					status = true;

					// Recupere les valeurs des attributs a comparer
					rulesValueAsString = this.getValue();
					rulesValueAsPattern = this.getPattern();
					netcdfValueAsString = netcdfAttribute.getValue();
					try {
						rulesValueAsNumber = Double.parseDouble(this.getValue());
					} catch (Exception e) {
						rulesValueAsNumber = null;
					}
					try {
						netcdfValueAsNumber = Double.parseDouble(netcdfAttribute.getValue());
					} catch (Exception e) {
						netcdfValueAsNumber = null;
					}

					// La valeur de l'attribut rgle est optionnelle
					if ((rulesValueAsString == null) && (rulesValueAsPattern == null)) {
						return status;
					}

					// Si la valeur de l'attribut netcdf est absente 
					if (netcdfValueAsString == null) {
						String [] tab =  {
								String.valueOf(ErreurRegles.ATT_VALUE),
								this.getValue(),
								this.getName()};
						lstErreur.add(tab);
						return status;
					}

					
					if (rulesValueAsString != null){
						// Comparer les valeurs comme des chaines 
						if (rulesValueAsString.equals(netcdfValueAsString) == true){
							equals = true;
						}
						// Comparer les valeurs comme des nombres
						if ((rulesValueAsNumber != null) && (netcdfValueAsNumber != null)){
							if (rulesValueAsNumber.equals(netcdfValueAsNumber)){
								equals = true;			
							}
						}
						// Si les valeurs sont diffrentes
						if (equals == false) {
							String [] tab = {
									String.valueOf(ErreurRegles.ATT_VALUE),
									this.getValue(),
									this.getName()};
							lstErreur.add(tab);
						}
					}
					else {
						// Si l'attribut a un pattern
						if (rulesValueAsPattern != null) {
							Pattern pattern = Pattern.compile(rulesValueAsPattern);
							Matcher match = pattern.matcher(netcdfValueAsString);
							if (match.matches() == false) {
								String [] tab = {
										String.valueOf(ErreurRegles.ATT_VALUE),
										rulesValueAsPattern,
										this.getName()};
								lstErreur.add(tab);
							}
						}
					}
				}
			}
		}
		return status;
	}

    
	/**
	 * 
	 * 
	 */
	public ArrayList trouver(ArrayList lst, String ruleLevel) {
		ArrayList<String []> lstErreur = new ArrayList<String []>();
		boolean exists = false;
		
		Iterator iterLst = lst.iterator();
		while (iterLst.hasNext() && exists == false) {
			CoAttribute attribute = (CoAttribute) iterLst.next();
			if (this.egaliteAvec(attribute, lstErreur) == true) {
				exists = true;
			}
		}

		if (exists == false) {
			if (lstErreur.isEmpty() == true) {
				String [] tab = {
						String.valueOf(ErreurRegles.ATT_NOT_FOUND),
						this.getName()};
				lstErreur.add(tab);
			}
		}
		return lstErreur;
	}
}
