package oco.structure;

import java.util.ArrayList;
import java.util.Iterator;

import oco.erreur.ErreurRegles;
import oco.traitement.ConstantesXml;

public class CoDimension extends ElementSimple {
	
	// pour une dimension de variable
	Integer rank = null;

	/**
	 * Constructeur
	 * 
	 */
	public CoDimension() {
		super();
	}

	public CoDimension(String p_name) {
		super(p_name);
	}
	
	/**
	 * Accesseurs
	 * 
	 */
	public Integer getRank() {
		return rank;
	}

	public void setRank(String rank) {
		this.rank = new Integer(rank);
	}
	
	/**
	 * 
	 * 
	 */
	public boolean equals(Object ob) {
		boolean retour = false;
		if (ob instanceof CoDimension) {
			CoDimension dim = (CoDimension)ob;
			if (dim.getName().equals(this.getName())) {
				retour = true;
			}
		}
		return retour;
	}
	
	/**
	 * 
	 * 
	 */
	public ArrayList trouver(ArrayList netcdfList, String ruleLevel) {
		ArrayList<String []> lstErreur = new ArrayList<String []>();
		CoDimension netcdfDimension = null;
		boolean exists = false;

		// Verifier l'existance de la dimension
		if (this.rank == null) {
			Iterator iterLst = netcdfList.iterator();
			while (iterLst.hasNext() && exists == false) {
				CoDimension dim = (CoDimension) iterLst.next();
				if (this.equals(dim)) {
					exists = true;
					netcdfDimension = dim;
				}
			}
		}
		else {
			try {
				CoDimension dim = (CoDimension) netcdfList.get(this.rank.intValue() - 1);
				if (this.equals(dim)) {
					exists = true;
					netcdfDimension = dim;
				}
			}catch (IndexOutOfBoundsException exception) {
				exists = false;
			}
		}
		
		if ((exists == false) && (ruleLevel != ConstantesXml.OPTIONAL)) {
			String [] tab = {
				String.valueOf(ErreurRegles.DIM_NOT_FOUND),
				this.getName()};
			lstErreur.add(tab);
		}
		
		// Verifier la valeur de la dimension
		if (exists == true) {
			if (this.getValue() != null){
				if (this.getValue().equals(netcdfDimension.getValue()) == false) {
					String [] tab = {
							String.valueOf(ErreurRegles.DIM_VALUE),
							this.getName(),
							this.getValue()};
					lstErreur.add(tab);
				}
			}
		}
		return lstErreur;
	}
}
