package oco.structure;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import oco.erreur.ErreurRegles;
import oco.traitement.ConstantesXml;

public class CoVariable extends ElementCompose {

    // Criteres de selection
    protected Critere selection = null;
    
    // Criteres de verification
    protected Critere verification = null;

    public String charValue = null;

    
	/**
	 * Constructeur
	 * 
	 */
    public CoVariable() {
        super();
        elementList.put(ConstantesXml.DIMENSION, new ArrayList());
        elementList.put(ConstantesXml.ATTRIBUTE, new ArrayList());
    }
    
    
    
	/*************************************************************
	 * 
	 * Fichier netdcf
	 * 
	 *************************************************************/
    
    public ArrayList<ElementStructure> getDimensions() {
        return (ArrayList)elementList.get(ConstantesXml.DIMENSION);
    }

    public ArrayList<ElementStructure> getAttribute() {
        return (ArrayList)elementList.get(ConstantesXml.ATTRIBUTE);
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getCharValue() {
		return charValue;
	}

	public void setCharValue(String charValue) {
		this.charValue = charValue;
	}
	
	
	
	/*************************************************************
	 * 
	 * Fichier de regle
	 * 
	 *************************************************************/

    public void setCritereSelection(Critere critereIdentify) {
    	// Renseigner l'attribut selection
    	this.selection = critereIdentify;

    	// Renseigner aussi l'attribut identifyBy
       	if (critereIdentify.getName() != null) {
        	if (this.identifyBy != "") {
        		this.identifyBy += ", ";
        	}
       		this.identifyBy += "name " + critereIdentify.getName().toString();
    	}
       	if (critereIdentify.getPattern() != null) {
        	if (this.identifyBy != "") {
        		this.identifyBy += ", ";
        	}
       		this.identifyBy += "pattern " + critereIdentify.getPattern().toString();
    	}
    	if (critereIdentify.dimensionCount != null) {
        	if (this.identifyBy != "") {
        		this.identifyBy += ", ";
        	}
    		this.identifyBy += "dimension_count " + critereIdentify.dimensionCount.toString();
    	}
    	if (critereIdentify.getDimensions() != null) {
    		Iterator iter = critereIdentify.getDimensions().iterator();
    		while (iter.hasNext()) { 
    			CoDimension dimension = (CoDimension) iter.next();
            	if (this.identifyBy != "") {
            		this.identifyBy += ", ";
            	}
    			this.identifyBy += "dimension " + dimension.getName();
				if (dimension.getRank() != null) {
					this.identifyBy += " rank " + dimension.getRank().toString();
				}
    		}
    	}
    }

    public void setCritereVerification(Critere critVerification) {
    	verification = critVerification;
    }

    
	/**
	 * 
	 * 
	 */
	public ArrayList trouver(ArrayList netcdfVariableList, String ruleLevel) {
		ArrayList<String []> lstErreur = new ArrayList<String []>();
		String name = "";

		// bloc IDENTIFY
		if (this.selection.trouver(netcdfVariableList, ruleLevel).isEmpty() == true) {
			this.selection.elementBlocLevel = this.elementBlocLevel;
			// pour les messages d'erreur
			if (this.getName() == null) {

				if ((this.selection.getFoundVariables().size() == 1) &&
					(((CoVariable)this.selection.getFoundVariables().get(0)).getName() != null))
				{
					name = ((CoVariable)this.selection.getFoundVariables().get(0)).getName();
				}
				this.setName(name);
			}
			
			// bloc MUST_VERIFY optionel
			if (this.verification != null) {
				this.verification.elementBlocLevel = this.elementBlocLevel;
				this.verification.checkFoundVariables(lstErreur, this.selection.getFoundVariables());
			}
			
		} else {
			String [] tab = {String.valueOf(ErreurRegles.VAR_NOT_FOUND), this.identifyBy};
			lstErreur.add(tab);
		}
		return lstErreur;
	}
	
	/**
	 * 
	 */
	public boolean variableExiste(List lst) {
		ArrayList aList = (ArrayList) lst;
		String ruleLevel = null;
		return (selection.trouver(aList, ruleLevel).isEmpty());
	}
	
	/**
	 * 
	 */
	public ArrayList<String []> verifierVariable() {
		ArrayList<String []> lstErreur = new ArrayList<String []>();
		if (this.verification != null) {
			this.verification.checkFoundVariables(lstErreur, selection.getFoundVariables());
		}
		return lstErreur;
	}

}
