package oco.structure;

import java.util.ArrayList;

import oco.traitement.ConstantesXml;


/**
 * Element d'une regle
 * 
 */
public abstract class ElementStructure {

	private boolean isComposed  = false;
	
	private String name = null;
	
	private String value = null;
	
	private String pattern = null;
	
    // Pour les messages d'erreur
    public String identifyBy = "";
    
    // MANDATORY, OPTIONAL, AT_LEAST
    public String elementBlocLevel = null;
    
    // ERROR, WARNING
    public String elementErrorLevel = null;


	/**
	 * Constructeur
	 * 
	 */
	public ElementStructure() {
		super();
	}
	
	/**
	 * Accesseurs
	 * 
	 */
	public String getName() {
		return this.name;
	}

	public void setName(String p_name) {
		this.name = p_name;
	}
	
	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}
	
	public String getPattern() {
		return this.pattern;
	}

	public void setPattern(String p_pattern) {
		this.pattern = p_pattern;
	}

	public void setCompose(boolean p_isComposed){
		this.isComposed = p_isComposed;
	}

	public boolean isComposed() {
		return this.isComposed;
	}

	public String getElementErrorLevel() {
		return this.elementErrorLevel;
	}

	public void setElementErrorLevel(String p_errorLevel) {
		this.elementErrorLevel = p_errorLevel;
	}

	/**
	 * @return nom de la classe
	 * COATTRIBUTE -> ATTRIBUTE
	 * CODIMENSION -> DIMENSION
	 * COVARIABLE -> VARIABLE
	 */
	public String toString() {
		String string = null;
		string = this.getClass().getSimpleName().toUpperCase();
		if (string.startsWith("CO")) {
			string = string.replaceFirst("CO", "");
		}
		return string;
	}

	/**
	 * trouver
	 * 
	 */
	public abstract ArrayList trouver(ArrayList lst, String ruleLevel);

}
