package oco.structure;

import oco.traitement.ConstantesXml;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class FactoryElementStructurel {

	/**
	 * 
	 * 
	 */
	public static ElementStructure createElementStructurel(Object donneesRegles) {
		ElementStructure elem = null;

		Node noeudDonneesRacine = (Node) donneesRegles;

		if (noeudDonneesRacine.getNodeName().equals(ConstantesXml.DIMENSION)) {
			elem = recupererDimension(noeudDonneesRacine);
		}
		if (noeudDonneesRacine.getNodeName().equals(ConstantesXml.GLOBAL_ATTR)) {
			elem = recupererAttribut(noeudDonneesRacine);
		}
		if (noeudDonneesRacine.getNodeName().equals(ConstantesXml.VARIABLE)) {
			elem = recupererVariable(noeudDonneesRacine);
		}
		if (noeudDonneesRacine.getNodeName().equals(ConstantesXml.MUTEX)) {
			elem = recupererMutex(noeudDonneesRacine);
		}
		return elem;
	}

	/**
	 * 
	 * 
	 */
	public static CoVariable createSpecialVariable(Object donneesRegles) {

		Node noeudDonneesRacine = (Node) donneesRegles;
		NamedNodeMap lstAttribut = noeudDonneesRacine.getAttributes();
		CoVariable var = new CoVariable();
		Critere identificateur = new Critere();

		for (int i = 0; i < lstAttribut.getLength(); i++) {
			Node attribut = lstAttribut.item(i);
			if (attribut.getNodeName().equals(ConstantesXml.NAME)) {
				identificateur.setName(attribut.getNodeValue());
				identificateur.setDimensionCount("1");
				identificateur.setType("char");
				var.setName(identificateur.getName());
			}
			if (attribut.getNodeName().equals(ConstantesXml.VALUE)) {
				var.setCharValue(attribut.getNodeValue());
			}
		}
		var.setCritereSelection(identificateur);
		return var;
	}

	/**
	 * 
	 * 
	 */
	private static CoDimension recupererDimension(Node noeudRacine) {
		CoDimension dim = new CoDimension();
		
		NamedNodeMap lstAttribut = noeudRacine.getAttributes();

		for (int k = 0; k < lstAttribut.getLength(); k++) {
			Node attribut = lstAttribut.item(k);
			if (attribut.getNodeName().equals(ConstantesXml.NAME)) {
				dim.setName(attribut.getNodeValue());
			}
			if (attribut.getNodeName().equals(ConstantesXml.VALUE)) {
				dim.setValue(attribut.getNodeValue());
			}
			if (attribut.getNodeName().equals(ConstantesXml.RANK)) {
				dim.setRank(attribut.getNodeValue());
			}
		}
		return dim;
	}

	/**
	 * 
	 * 
	 */
	public static CoAttribute recupererAttribut(Node noeudDonneesRacine) {
		CoAttribute att = new CoAttribute();

		NamedNodeMap lstAttribut = noeudDonneesRacine.getAttributes();

		for (int i = 0; i < lstAttribut.getLength(); i++) {
			Node attribut = lstAttribut.item(i);
			if (attribut.getNodeName().equals(ConstantesXml.NAME)) {
				att.setName(attribut.getNodeValue());
			}
			if (attribut.getNodeName().equals(ConstantesXml.VALUE)) {
				att.setValue(attribut.getNodeValue());
			}
			if (attribut.getNodeName().equals(ConstantesXml.PATTERN)) {
				att.setPattern(attribut.getNodeValue());
			}
			if (attribut.getNodeName().equals(ConstantesXml.ERROR_LEVEL)) {
				att.setElementErrorLevel(attribut.getNodeValue());
			}
		}
		return att;
	}

	/**
	 * Recuperer la variable du fichier de regle
	 * 
	 */
	private static CoVariable recupererVariable(Node noeudDonneesRacine) {
		CoVariable variable = new CoVariable();
		NamedNodeMap lstAttribut = noeudDonneesRacine.getAttributes();
		// Si attribut optionel ERROR_LEVEL
		for (int i = 0; i < lstAttribut.getLength(); i++) {
			Node attribut = lstAttribut.item(i);
			if (attribut.getNodeName().equals(ConstantesXml.ERROR_LEVEL)) {
				variable.setElementErrorLevel(attribut.getNodeValue());
			}
		}
		
		// Pour chaque element de la regle
		if (noeudDonneesRacine.hasChildNodes()) {
			NodeList listEnfant = noeudDonneesRacine.getChildNodes();
			
			for (int i = 0; i < listEnfant.getLength(); i++) {
				Node noeudAttribut = listEnfant.item(i);
				if (noeudAttribut.getNodeType() == Node.ELEMENT_NODE) {

					// Si critere d'identification
					if (noeudAttribut.getNodeName().equals(ConstantesXml.IDENTIFY)) {

						Critere critereIdentify = new Critere();
						NodeList listIdentify = noeudAttribut.getChildNodes();
						
						for (int j = 0; j < listIdentify.getLength(); j++) {
							Node identifiant = listIdentify.item(j);
							if (identifiant.getNodeType() == Node.ELEMENT_NODE) {

								if (identifiant.getNodeName().equals(ConstantesXml.NAME)) {
									String valueOrPattern = null;
									valueOrPattern = recupererNom(identifiant);
									if (valueOrPattern != null){
										critereIdentify.setName(valueOrPattern);
										variable.setName(valueOrPattern);
									}
									else {
										valueOrPattern = recupererPattern(identifiant);
										critereIdentify.setPattern(valueOrPattern);
										variable.setPattern(valueOrPattern);
									}
								}

								if (identifiant.getNodeName().equals(ConstantesXml.DIMENSION)) {
									critereIdentify.ajouterDimension(recupererDimension(identifiant));
								}
								if (identifiant.getNodeName().equals(ConstantesXml.MUTEX)) {
									critereIdentify.ajouterMutex(recupererMutex(identifiant));
								}
								if (identifiant.getNodeName().equals(ConstantesXml.DIMENSION_COUNT)) {
									critereIdentify.setDimensionCount(recupererNbDimension(identifiant));
								}
							}
						}
						variable.setCritereSelection(critereIdentify);
					}
						
					// Si critere de verification
					if (noeudAttribut.getNodeName().equals(ConstantesXml.MUST_VERIFY)) {

						Critere verificateur = new Critere();
						NodeList listVerify = noeudAttribut.getChildNodes();
						
						for (int j = 0; j < listVerify.getLength(); j++) {
							Node verify = listVerify.item(j);
							
							if (verify.getNodeType() == Node.ELEMENT_NODE) {
								if (verify.getNodeName().equals(ConstantesXml.TYPE)) {
									verificateur.setType(recupererType(verify).getName());
								}
								if (verify.getNodeName().equals(ConstantesXml.DIMENSION)) {
									verificateur.ajouterDimension(recupererDimension(verify));
								}
								if (verify.getNodeName().equals(ConstantesXml.ATTRIBUTE)) {
									verificateur.ajouterAttribut(recupererAttribut(verify));
								}
								if (verify.getNodeName().equals(ConstantesXml.MUTEX)) {
									verificateur.ajouterMutex(recupererMutex(verify));
								}
								if (verify.getNodeName().equals(ConstantesXml.DIMENSION_COUNT)) {
									verificateur.setDimensionCount(recupererNbDimension(verify));
								}
							}
						}
						variable.setCritereVerification(verificateur);
					}
				}
			}
		}
		return variable;
	}
	
	/**
	 * 
	 * 
	 */
	private static Mutex recupererMutex(Node noeudDonneesRacine) {
		Mutex mutex = null;
		String errorLevel = null;
		NamedNodeMap lstAttribut = noeudDonneesRacine.getAttributes();

		for (int i = 0; i < lstAttribut.getLength(); i++) {
			Node attribut = lstAttribut.item(i);
			if (attribut.getNodeName().equals(ConstantesXml.ERROR_LEVEL)) {
				errorLevel = attribut.getNodeValue();
			}
		}

		if (noeudDonneesRacine.hasChildNodes()) {
			NodeList listEnfant = noeudDonneesRacine.getChildNodes();
			for (int i = 0; i < listEnfant.getLength(); i++) {
				Node noeudEnfant = listEnfant.item(i);
				if (noeudEnfant.getNodeType() == Node.ELEMENT_NODE) {
					if (noeudEnfant.getNodeName().equals(ConstantesXml.TYPE)) {
						if ( mutex == null) {
							mutex = new Mutex(ConstantesXml.TYPE);
						}
						mutex.ajouterElement(recupererType(noeudEnfant));
					}
					if (noeudEnfant.getNodeName().equals(ConstantesXml.DIMENSION)) {
						if ( mutex == null) {
							mutex = new Mutex(ConstantesXml.DIMENSION);
						}
						mutex.ajouterElement(recupererDimension(noeudEnfant));

					}
					if (noeudEnfant.getNodeName().equals(ConstantesXml.VARIABLE)) {
						if ( mutex == null) {
							mutex = new Mutex(ConstantesXml.VARIABLE);
						}
						mutex.ajouterElement(recupererVariable(noeudEnfant));
					}
				}
			}
		}
		mutex.setElementErrorLevel(errorLevel);
		return mutex;
	}
	
	/**
	 * 
	 * 
	 */
	private static String recupererNom(Node noeud) {
		String nom = null;
		NamedNodeMap lstAttribut = noeud.getAttributes();

		for (int k = 0; k < lstAttribut.getLength(); k++) {
			Node attribut = lstAttribut.item(k);
			if (attribut.getNodeName().equals(ConstantesXml.VALUE)) {
				nom = attribut.getNodeValue();
			}
		}
		return nom;
	}
	
	/**
	 * 
	 * 
	 */
	private static String recupererPattern(Node noeud) {
		String string = null;
		NamedNodeMap lstAttribut = noeud.getAttributes();

		for (int k = 0; k < lstAttribut.getLength(); k++) {
			Node attribut = lstAttribut.item(k);
			if (attribut.getNodeName().equals(ConstantesXml.PATTERN)) {
				string = attribut.getNodeValue();
			}
		}
		return string;
	}

	/**
	 * 
	 * 
	 */
	private static Type recupererType(Node noeud) {
		Type type = new Type();

		NamedNodeMap lst = noeud.getAttributes();

		for (int k=0;k<lst.getLength();k++) {
			Node noeudEnfant = lst.item(k);
			if (noeudEnfant.getNodeName().equals(ConstantesXml.VALUE)) {
				type.setName(noeudEnfant.getNodeValue());
			}
		}
		return type;
	}

	/**
	 * 
	 * 
	 */
	private static String recupererNbDimension(Node noeud) {
		String nbDimension = null;

		NamedNodeMap lst = noeud.getAttributes();

		for (int k=0;k<lst.getLength();k++) {
			Node noeudEnfant = lst.item(k);
			if (noeudEnfant.getNodeName().equals(ConstantesXml.VALUE)) {
				nbDimension = noeudEnfant.getNodeValue();
			}
		}
		return nbDimension;
	}
}
