package oco.tests.junits0;

import java.util.ArrayList;

import oco.erreur.InvalidXmlException;
import oco.erreur.RessourceException;
import oco.structure.CoAttribute;
import oco.structure.CoDimension;
import oco.structure.CoVariable;
import oco.traitement.ConstantesXml;
import oco.traitement.XmlManager;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class ChargementCdf {
	ArrayList<CoDimension> lstDimensions = null;
	ArrayList<CoAttribute> lstGlobalAttrs = null;
	ArrayList<CoVariable> lstVariables = null;

	public void charger(String nomFichier) {

		XmlManager xmlCdf = null;

		try {
			xmlCdf = new XmlManager(nomFichier,null);
		} catch (RessourceException e) {
			e.printStackTrace();
		} catch (InvalidXmlException e) {
			e.printStackTrace();
		}

		Document doc = xmlCdf.getDoc();
		NodeList lstXmlCdf = doc.getDocumentElement().getChildNodes();
		for (int i = 0;i<lstXmlCdf.getLength(); i++) {
			Node xmlElemCdf = lstXmlCdf.item(i);
			if (xmlElemCdf.getNodeType() == Node.ELEMENT_NODE) {
				if (xmlElemCdf.getNodeName().equals(ConstantesXml.DIMENSION)) {
					if (lstDimensions == null) {
						lstDimensions = new ArrayList<CoDimension>();
					}
					lstDimensions.add(recupererDimension(xmlElemCdf));
				}
				if (xmlElemCdf.getNodeName().equals(ConstantesXml.GLOBAL_ATTR)) {
					if (lstGlobalAttrs == null) {
						lstGlobalAttrs = new ArrayList<CoAttribute>();
					}
					lstGlobalAttrs.add(recupererAttribute(xmlElemCdf));
				}
				if (xmlElemCdf.getNodeName().equals(ConstantesXml.VARIABLE)) {
					if (lstVariables == null) {
						lstVariables = new ArrayList<CoVariable>();
					}
					lstVariables.add(recupererVariable(xmlElemCdf));
				}
			}

		}
		System.out.println("FINI");
	}

	private CoDimension recupererDimension(Node noeudRacine) {
		CoDimension  dim = new CoDimension();
		NamedNodeMap lstAttribut = noeudRacine.getAttributes();

		for (int k=0;k<lstAttribut.getLength(); k++) {
			Node attribut = lstAttribut.item(k);
			if (attribut.getNodeName().equals(ConstantesXml.NAME)) {
				dim.setName(attribut.getNodeValue());
			}
			if (attribut.getNodeName().equals(ConstantesXml.VALUE)) {
				dim.setName(attribut.getNodeValue());
			}
		}
		return dim;


	}

	private CoAttribute recupererAttribute(Node noeudDonneesRacine) {
		CoAttribute  att = new CoAttribute();
		NamedNodeMap lstAttribut = noeudDonneesRacine.getAttributes();

		for (int i=0;i<lstAttribut.getLength();i++) {
			Node attribut = lstAttribut.item(i);
			if (attribut.getNodeName().equals(ConstantesXml.NAME)) {
				att.setName(attribut.getNodeValue());
			}
			if (attribut.getNodeName().equals(ConstantesXml.VALUE)) {
				att.setValue(attribut.getNodeValue());
			}
		}
		return att;
	}

	private CoVariable recupererVariable(Node noeudDonneesRacine) {
		CoVariable  var = new CoVariable();
		if (noeudDonneesRacine.hasChildNodes()) {
			NodeList listEnfant = noeudDonneesRacine.getChildNodes();
			for (int i=0;i<listEnfant.getLength(); i++) {
				Node noeudAttribut = listEnfant.item(i);
				if (noeudAttribut.getNodeType() == Node.ELEMENT_NODE) {
					if (noeudAttribut.getNodeName().equals(ConstantesXml.NAME)) {
						var.setName(noeudAttribut.getAttributes().item(0).getNodeValue());
					}
					if (noeudAttribut.getNodeName().equals(ConstantesXml.TYPE)) {
						var.setType(noeudAttribut.getAttributes().item(0).getNodeValue());
					}
					if (noeudAttribut.getNodeName().equals(ConstantesXml.DIMENSION)) {
						var.getDimensions().add(recupererDimension(noeudAttribut));
					}
					if (noeudAttribut.getNodeName().equals(ConstantesXml.ATTRIBUTE)) {
						var.getAttribute().add(recupererAttribute(noeudAttribut));
					}
				}
			}
		}
		return var;


	}

	public ArrayList getLstDimensions() {
		return lstDimensions;
	}

	public ArrayList getLstGlobalAttrs() {
		return lstGlobalAttrs;
	}

	public ArrayList getLstVariables() {
		return lstVariables;
	}

}
