package oco.tests.junits0;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Properties;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import oco.erreur.InvalidXmlException;
import oco.erreur.MessageErrorManager;
import oco.erreur.RessourceException;
import oco.regles.Mandatory;
import oco.regles.Regle;
import oco.structure.ElementStructure;
import oco.structure.FactoryElementStructurel;
import oco.traitement.XmlManager;

public class TestExecutionRegleAvecMessage {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ChargementCdf chargeur = new ChargementCdf();
		chargeur.charger("tests/Cdf/D_test5.xml");

		ArrayList [] tabLst = {chargeur.getLstDimensions(),
								chargeur.getLstGlobalAttrs(),
								chargeur.getLstVariables()};

		XmlManager xmlRegle = null;

		ElementStructure elemStruct = null;
		MessageErrorManager gestionMessageErreur = null;
		Regle rule = null;

		try {
			xmlRegle = new XmlManager("tests/Regles/R_test9.xml",null);
		} catch (RessourceException e) {
			e.printStackTrace();
		} catch (InvalidXmlException e) {
			e.printStackTrace();
		}

		try {
			gestionMessageErreur = new MessageErrorManager(chargerFichierProperties("MsgErr.properties"));
		} catch (RessourceException exc) {
			gestionMessageErreur = new MessageErrorManager(null);
			// Message error
			gestionMessageErreur.end();
			return;
		}

		Document doc = xmlRegle.getDoc();
		NodeList lstXmlRule = doc.getDocumentElement().getChildNodes();

		for (int i = 0;i<lstXmlRule.getLength(); i++) {
			Node xmlRule = lstXmlRule.item(i);
			if (xmlRule.getNodeType() == Node.ELEMENT_NODE) {

				rule = new Mandatory(null,tabLst, gestionMessageErreur, null);
				// boucle sur les element structuraux
				NodeList lstXmlElemStruct = xmlRule.getChildNodes();

				for (int j = 0;j<lstXmlElemStruct.getLength(); j++) {
					Node xmlElemStruct = lstXmlElemStruct.item(j);
					if (xmlElemStruct.getNodeType() == Node.ELEMENT_NODE && rule != null) {
						elemStruct = FactoryElementStructurel.createElementStructurel(xmlElemStruct);
						rule.add(elemStruct);
					}
				}
			}
		}
		rule.executerRegles();
		gestionMessageErreur.end();
	}

	private static Properties chargerFichierProperties(String fichierProperties) throws RessourceException {
		//final String fichierDeConf = ;
        Properties properties = new Properties();
        InputStream is = null;

        try {
            is = new FileInputStream(new File(fichierProperties));
        } catch (FileNotFoundException e) {
        	throw new RessourceException("Impossible de trouver le fichier des properties de l'application");
        }

        try {
            properties.load(is);
        } catch (IOException e) {
        	throw new RessourceException("Impossible de charger le fichier des properties de l'application");
        }

        return properties;
	}
}
