package oco.tests.junits0;

import java.util.ArrayList;
import java.util.Iterator;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import oco.erreur.InvalidXmlException;
import oco.erreur.RessourceException;
import oco.structure.ElementStructure;
import oco.structure.FactoryElementStructurel;
import oco.traitement.ConstantesXml;
import oco.traitement.XmlManager;

public class TestParsingFichierRegle {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ArrayList toto = renvoieListe("tests/oriente.1.2.4.xml");
		System.out.println(toto.size());
		ArrayList lst = null ;
		lst = renvoieDimension(toto, ConstantesXml.DIMENSION);
		System.out.println(lst.size());
		lst = renvoieDimension(toto, ConstantesXml.ATTRIBUTE);
		System.out.println(lst.size());
		lst = renvoieDimension(toto, ConstantesXml.VARIABLE);
		System.out.println(lst.size());
	}

	public static ArrayList renvoieListe(String nomFichier) {

		XmlManager xmlRegle = null;

		ElementStructure elemStruct = null;

		ArrayList<ElementStructure> rule = new ArrayList<ElementStructure>();

		try {
			xmlRegle = new XmlManager(nomFichier,null);
		} catch (RessourceException e) {
			e.printStackTrace();
		} catch (InvalidXmlException e) {
			e.printStackTrace();
		}

		Document doc = xmlRegle.getDoc();
		NodeList lstXmlRule = doc.getDocumentElement().getChildNodes();
		for (int i = 0;i<lstXmlRule.getLength(); i++) {
			Node xmlRule = lstXmlRule.item(i);
			if (xmlRule.getNodeType() == Node.ELEMENT_NODE) {

				// boucle sur les element structuraux
				NodeList lstXmlElemStruct = xmlRule.getChildNodes();

				for (int j = 0;j<lstXmlElemStruct.getLength(); j++) {
					Node xmlElemStruct = lstXmlElemStruct.item(j);
					if (xmlElemStruct.getNodeType() == Node.ELEMENT_NODE && rule != null) {
						elemStruct = FactoryElementStructurel.createElementStructurel(xmlElemStruct);
						rule.add(elemStruct);
					}
				}
			}
		}
		return rule;
	}

	public static ArrayList renvoieDimension(ArrayList lst, String type) {
		ArrayList<ElementStructure> dim = new ArrayList<ElementStructure>();
		Iterator iter = lst.iterator();

		while (iter.hasNext()) {
			ElementStructure elem = (ElementStructure) iter.next();
			if (elem.toString().equals(type)) {
				dim.add(elem);
			}
		}
		return dim;
	}
}
