package oco.tests.junits0;

import java.io.File;
import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import oco.erreur.RessourceException;
import oco.traitement.CoNetcdfFile;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class TestXPath {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Document doc = null;
		String nomFichierRegle = "spectral.1.2.2.xml";
	    try {
        	// Chargement du fichier des rgles
        	doc = chargeEtVerifieXml(nomFichierRegle);
        } catch (RessourceException e) {
			// Sortie Standard

		}

        try {
        	verifierApplicabilite(doc, null);
        } catch (RessourceException ressource) {

        }


	}
	private static Document chargeEtVerifieXml(String pXML) throws RessourceException {
		File fichierRegle = new File(pXML);
		// Verification XSD correcte.

		Document doc = null;
		DocumentBuilder documentBuilder = null;
		//System.setProperty("javax.xml.parsers.DocumentBuilderFactory", "org.apache.xerces.jaxp.DocumentBuilderFactoryImpl");
		// On prend l'implementation du DocumentBuiderFactory defini dans le JDK par defaut : celui fourni par apache
		DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
		try {
			documentBuilder = documentBuilderFactory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			throw new RessourceException("Configuration du parseur incorrecte");
		}
		try {
			doc = documentBuilder.parse(fichierRegle);
		} catch (SAXException e) {
			throw new RessourceException("Erreur de parsing SAX");
		} catch (IOException e) {
			throw new RessourceException("Impossible de charger le fichier des rgles");
		}
		return doc;
	}

	private static void verifierApplicabilite(Document doc, CoNetcdfFile fichierCdf) throws RessourceException {
         String expression = "/RULES/APPLICABLE_IF/GLOBAL_ATTRIBUTE";
         NodeList conditionApplication = null;

         try {
             //cration du XPath
             XPathFactory fabrique = XPathFactory.newInstance();
             XPath xpath = fabrique.newXPath();

             //valuation de l'expression XPath
             XPathExpression exp = xpath.compile(expression);
             conditionApplication = (NodeList)exp.evaluate(doc,XPathConstants.NODESET);
             for (int i=0; i< conditionApplication.getLength();i++) {
            	 Node condition = conditionApplication.item(i);
            	 NamedNodeMap lstAttribut = condition.getAttributes();

     			for (int j=0;j<lstAttribut.getLength();j++) {
     				Node condition1 = lstAttribut.item(j);
     				System.out.println(condition1.getNodeName() + " " + condition1.getNodeValue());
     			}
             }
             //System.out.println(conditionApplication.getNodeName());
         }catch(XPathExpressionException xpee){
        	 xpee.printStackTrace();
         }
	}
}
