package oco.tests.junits0;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;
import org.xml.sax.SAXParseException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

public class TestXsdValidator {

    /**
     * @param args
     */
    public static void main(String[] args) {
        File pSchema = new File("validator2.xsd");
        XMLReader reader = null;

        try {
            reader = XMLReaderFactory.createXMLReader();
        } catch (SAXException e) {
            e.printStackTrace();
        }

        try {
            reader.setFeature("http://xml.org/sax/features/validation", true);
        } catch (SAXNotRecognizedException e) {
            e.printStackTrace();
        } catch (SAXNotSupportedException e) {
            e.printStackTrace();
        }

        try {
            reader.setFeature(
                    "http://apache.org/xml/features/validation/schema", true);
        } catch (SAXNotRecognizedException e) {
            e.printStackTrace();
        } catch (SAXNotSupportedException e) {
            e.printStackTrace();
        }
        String id = "http://apache.org/xml/properties/schema/external-noNamespaceSchemaLocation";
        Object value = pSchema.getAbsolutePath();

        try {
            reader.setProperty(id, value);
        } catch (SAXNotRecognizedException e) {
            e.printStackTrace();
        } catch (SAXNotSupportedException e) {
            e.printStackTrace();
        }

        ErrorZarb handler = new ErrorZarb();
        reader.setErrorHandler(handler);
        InputSource source = null;

        try {
            source = new InputSource(new FileInputStream(new File("tests/XSD/test14.xml")));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }

        try {
            reader.parse(source);
        } catch (IOException e) {
            e.printStackTrace();
        } catch (SAXException e) {
            e.printStackTrace();
        }

        if (handler.hasErrorMessage() == true) {
            System.out.println(handler.getMessage());
            return;
        }
        System.out.println("Fichier correcte");
    }

}


class ErrorZarb implements ErrorHandler {
    StringBuffer message = null;

    public ErrorZarb() {
        message = new StringBuffer();
    }
    public void warning(SAXParseException exception) throws SAXException {
        // TODO Raccord de mthode auto-gnr
        message.append("Colonne :").append(exception.getColumnNumber()).append('\n').
        		append("Ligne :").append(exception.getLineNumber()).append('\n').
        		append(exception.getMessage()).append('\n');
    }

    public void error(SAXParseException exception) throws SAXException {
        // TODO Raccord de mthode auto-gnr
    	 message.append("Colonne :").append(exception.getColumnNumber()).append('\n').
 		append("Ligne :").append(exception.getLineNumber()).append('\n').
 		append(exception.getMessage()).append('\n');
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        // TODO Raccord de mthode auto-gnr
    	 message.append("Colonne :").append(exception.getColumnNumber()).append('\n').
 		append("Ligne :").append(exception.getLineNumber()).append('\n').
 		append(exception.getMessage()).append('\n');
    }

    public boolean hasErrorMessage(){
    	return message.length()>0;
    }

    public String getMessage() {
    	return message.toString();
    }
}
